/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : freemaster_tsa_table.h
**     Project     : MC56F84000_PWM_ADC_3trigger_single_channel
**     Processor   : MC56F84789VLL
**     Version     : Component 01.129, Driver 01.06, CPU db: 3.50.001
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2015-04-28, 15:58, # CodeGen: 1
**     Abstract    :
**          This component encapsulates the FreeMASTER driver. The FreeMASTER
**          driver implements all the features necessary to establish a communication
**          with the FreeMASTER visualization tool.
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file freemaster_tsa_table.h                                                  
** @version 01.06
** @brief
**          This component encapsulates the FreeMASTER driver. The FreeMASTER
**          driver implements all the features necessary to establish a communication
**          with the FreeMASTER visualization tool.
*/         
/*!
**  @addtogroup freemaster_tsa_table_module freemaster_tsa_table module documentation
**  @{
*/         

#include "FMSTR1.h"
/*
 * With TSA enabled, the user describes the global and static variables using
 * so-called TSA tables. There can be any number of tables defined in
 * the project files. Each table does have the identifier which should be
 * unique across the project.
 *
 * Note that you can declare variables as Read-Only or Read-Write.
 * The FreeMASTER driver denies any write access to the Read-Only variables
 * when TSA_SAFETY is enabled.
 */

/*
 * The TSA table definition begins with FMSTR_TSA_TABLE_BEGIN(table_id) macro.
 * The parameter "table_id" is ID of TSA table and needs to be added to TSA table list.
 * The table is closed using the FMSTR_TSA_TABLE_END() macro.
 *
 * After FMSTR_TSA_TABLE_BEGIN(table_id) macro insert TSA descriptors using following macros:
 *
 * FMSTR_TSA_RW_VAR(name, type) // read/write variable entry
 * FMSTR_TSA_RO_VAR(name, type) // read-only variable entry
 * FMSTR_TSA_STRUCT(struct_name) // structure type entry
 * FMSTR_TSA_MEMBER(struct_name, member_name, type) // structure member entry
 *
 * where:
 *
 * name - variable name. The variable must be defined in user source code
 * type - variable or member type. Only one of the pre-defined type constants may be used
 * struct_name - structure type name. The type must be defined (typedef) defined in user source code
 * member_name - structure member name, without the dot at the beginning
 *
 * Pre-defined variable/member type constants:
 *
 * FMSTR_TSA_UINT8 8-bit unsigned integer type
 * FMSTR_TSA_UINT16 16-bit unsigned integer type
 * FMSTR_TSA_UINT32 32-bit unsigned integer type
 * FMSTR_TSA_UINT64 64-bit unsigned integer type
 *
 * FMSTR_TSA_SINT8 8-bit signed integer type
 * FMSTR_TSA_SINT16 16-bit signed integer type
 * FMSTR_TSA_SINT32 32-bit signed integer type
 * FMSTR_TSA_SINT64 64-bit signed integer type
 *
 * FMSTR_TSA_FRAC16 fractional 16-bit data type
 * FMSTR_TSA_FRAC32 fractional 32-bit data type
 *
 * FMSTR_TSA_UFRAC16 Unsigned fractional 16-bit data type
 * FMSTR_TSA_UFRAC32 Unsigned fractional 32-bit data type
 *
 * FMSTR_TSA_FLOAT 4-byte standard IEEE floating point type
 * FMSTR_TSA_DOUBLE 8-byte standard IEEE floating point type
 * FMSTR_TSA_USERTYPE(name) Structure or union type. You must specify the type name as an argument
 *
 * Example:
 *
 * FMSTR_TSA_RW_VAR(var8,     FMSTR_TSA_UINT8)
 * FMSTR_TSA_STRUCT(FIRST_USER_STRUCT)
 * FMSTR_TSA_MEMBER(FIRST_USER_STRUCT, var16a,   FMSTR_TSA_UINT16)
 * FMSTR_TSA_MEMBER(FIRST_USER_STRUCT, var32a,   FMSTR_TSA_UINT32)
 * FMSTR_TSA_STRUCT(SECOND_USER_STRUCT)
 * FMSTR_TSA_MEMBER(SECOND_USER_STRUCT, var16b, FMSTR_TSA_UINT16)
 * FMSTR_TSA_MEMBER(SECOND_USER_STRUCT, var32b, FMSTR_TSA_UINT32)
 *
 */

//Uncomment following lines to try the example
//volatile byte example_var8;
//volatile word example_var16;

//FMSTR_TSA_TABLE_BEGIN(example_table)
//    FMSTR_TSA_RW_VAR(example_var8,     FMSTR_TSA_UINT8)
//    FMSTR_TSA_RO_VAR(example_var16,    FMSTR_TSA_UINT16)
//FMSTR_TSA_TABLE_END()

/*
 * This list describes all TSA tables which should be exported to the
 * FreeMASTER application.
 */

FMSTR_TSA_TABLE_LIST_BEGIN()
/* Register all TSA tables in your application here */

//    FMSTR_TSA_TABLE(table_id)
//Uncomment following line to try the example
//    FMSTR_TSA_TABLE(example_table)
//TSA tabled defined by component
    FMSTR_GEN_TSA_LIST()
FMSTR_TSA_TABLE_LIST_END()

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/

