/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : CMPD.c
**     Project     : MC65F84000_PWM_DAC_HSCMP
**     Processor   : MC56F84789VLL
**     Component   : Init_HSCMP
**     Version     : Component 01.009, Driver 01.09, CPU db: 3.50.001
**     Compiler    : CodeWarrior DSP C Compiler
**     Date/Time   : 2015-04-30, 14:15, # CodeGen: 1
**     Abstract    :
**          This file implements the HSCMP (CMPD) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : CMPD
**          Device                                         : CMPD
**          Settings                                       : 
**            Sample                                       : Disabled
**            Windowing                                    : Disabled
**            Filter sample count                          : 0
**            Filter sample period                         : 0
**            Sampling period                              : STOP
**            Invert control                               : Do NOT invert
**            Comparator output select                     : Unfiltered
**            Power mode                                   : Power saving
**            Hysteresis control                           : Level 0
**          Pins/Signals                                   : 
**            Positive input pins                          : Enabled
**              Positive input pin0                        : Disabled
**              Positive input pin1                        : Disabled
**              Positive input pin2                        : Disabled
**              Positive input pin3                        : Disabled
**              Positive input pin4                        : Enabled
**                Positive input pin4                      : DAC12b_Output
**                Positive input pin4 signal               : 
**              Positive input pin5                        : Disabled
**              Positive input pin7                        : Disabled
**            Negative input pins                          : Enabled
**              Negative input pin0                        : Enabled
**                Negative input pin0                      : GPIOA4/ANA4/ANC8/CMPD_IN0
**                Negative input pin0 signal               : 
**              Negative input pin1                        : Disabled
**              Negative input pin2                        : Disabled
**              Negative input pin3                        : Disabled
**              Negative input pin4                        : Disabled
**              Negative input pin5                        : Disabled
**              Negative input pin7                        : Disabled
**            Window/Sample input                          : Disabled
**            Output pin                                   : Enabled
**              Comparator output pin                      : GPIOF1/CLKO1/XB_IN7/CMPD_O
**              Comparator output pin signal               : 
**          Interrupts/DMA                                 : 
**            Rising or Falling compare                    : 
**              Interrupt                                  : INT_CMPD
**              Interrupt priority                         : default
**              ISR name                                   : 
**              Rising compare interrupt                   : Disabled
**              Falling compare interrupt                  : Disabled
**          Initialization                                 : 
**            Comparator module                            : Enabled
**            Initial positive input                       : P4
**            Initial negative input                       : M0
**            Enable peripheral clock                      : yes
**            Call Init method                             : yes
**     Contents    :
**         Init - void CMPD_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file CMPD.c
** @version 01.09
** @brief
**          This file implements the HSCMP (CMPD) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
*/         
/*!
**  @addtogroup CMPD_module CMPD module documentation
**  @{
*/         

/* MODULE CMPD. */

#include "CMPD.h"
  /* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  CMPD_Init (component Init_HSCMP)
**     Description :
**         This method initializes registers of the HSCMP module
**         according to the Peripheral Initialization settings.
**         Call this method in user code to initialize the module. By
**         default, the method is called by PE automatically; see "Call
**         Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void CMPD_Init(void)
{
  /* CMPD_CR1: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,SE=0,WE=0,??=0,PMODE=0,INV=0,COS=0,OPE=0,EN=0 */
  setReg16(CMPD_CR1, 0x00U);            
  /* CMPD_CR0: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,FILTER_CNT=0,??=0,??=0,HYSTCTR=0 */
  setReg16(CMPD_CR0, 0x00U);            
  /* CMPD_MUXCR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,PSEL=0,MSEL=0 */
  setReg16(CMPD_MUXCR, 0x00U);          
  /* CMPD_FPR: FILT_PER=0 */
  clrReg16Bits(CMPD_FPR, 0xFFU);        
  /* CMPD_CR1: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,SE=0,WE=0,??=0,PMODE=0,INV=0,COS=1,OPE=1,EN=0 */
  setReg16(CMPD_CR1, 0x06U);            
  /* CMPD_SCR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,IER=0,IEF=0,CFR=1,CFF=1,COUT=0 */
  setReg16(CMPD_SCR, 0x06U);            
  /* CMPD_CR0: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,FILTER_CNT=0,??=0,??=0,HYSTCTR=0 */
  setReg16(CMPD_CR0, 0x00U);            
  /* CMPD_MUXCR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,PSEL=4,MSEL=0 */
  setReg16(CMPD_MUXCR, 0x20U);          
  /* CMPD_CR1: EN=1 */
  setReg16Bits(CMPD_CR1, 0x01U);        
}


/* END CMPD. */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
