/** ###################################################################
**
**     (c) Freescale Semiconductor, Inc.
**     2004 All Rights Reserved
**
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/

/* const.h */

#include "port.h"
#include "arch.h"

/* General constants */
extern const char constNewline[];


/*
  DSP FUNCTION Library constants
*/
#if defined(SDK_LIBRARY) || defined(INCLUDE_DSPFUNC)

    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable8[8];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable16[16];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable32[32];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable64[64];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable128[128];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable256[256];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable512[512];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable1024[1024];
    EXPORT const CFrac16 dfr16CFFTTwiddleFactorTable2048[2048];

    EXPORT const CFrac16 dfr16RFFTTwiddleTable8[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable8br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable16[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable16br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable32[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable32br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable64[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable64br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable128[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable128br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable256[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable256br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable512[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable512br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable1024[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable1024br[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable2048[];
    EXPORT const CFrac16 dfr16RFFTTwiddleTable2048br[];

#endif
